Index: src/xml.c
===================================================================
RCS file: /data/cvs/libvirt/src/xml.c,v
retrieving revision 1.77
diff -u -p -r1.77 xml.c
--- src/xml.c	7 Jun 2007 13:50:18 -0000	1.77
+++ src/xml.c	26 Jun 2007 14:27:07 -0000
@@ -21,9 +21,11 @@
 #include "internal.h"
 #include "hash.h"
 #include "sexpr.h"
+#include "buf.h"
 #include "xml.h"
 #include "xs_internal.h" /* for xenStoreDomainGetNetworkID */
 
+#ifndef PROXY
 /**
  * virXMLError:
  * @conn: a connection if any
@@ -46,7 +48,6 @@ virXMLError(virConnectPtr conn, virError
                     errmsg, info, NULL, value, 0, errmsg, info, value);
 }
 
-#ifndef PROXY
 /**
  * virXPathString:
  * @xpath: the XPath string to evaluate
@@ -266,181 +267,7 @@ virXPathNodeSet(const char *xpath, xmlXP
     xmlXPathFreeObject(obj);
     return(ret);
 }
-#endif /* !PROXY */
-
-/**
- * virBufferGrow:
- * @buf:  the buffer
- * @len:  the minimum free size to allocate on top of existing used space
- *
- * Grow the available space of an XML buffer to at least @len bytes.
- *
- * Returns the new available space or -1 in case of error
- */
-static int
-virBufferGrow(virBufferPtr buf, unsigned int len)
-{
-    int size;
-    char *newbuf;
-
-    if (buf == NULL)
-        return (-1);
-    if (len + buf->use < buf->size)
-        return (0);
-
-    size = buf->use + len + 1000;
-
-    newbuf = (char *) realloc(buf->content, size);
-    if (newbuf == NULL) {
-        virXMLError(NULL, VIR_ERR_NO_MEMORY, _("growing buffer"), size);
-        return (-1);
-    }
-    buf->content = newbuf;
-    buf->size = size;
-    return (buf->size - buf->use);
-}
-
-/**
- * virBufferAdd:
- * @buf:  the buffer to dump
- * @str:  the string
- * @len:  the number of bytes to add
- *
- * Add a string range to an XML buffer. if len == -1, the length of
- * str is recomputed to the full string.
- *
- * Returns 0 successful, -1 in case of internal or API error.
- */
-int
-virBufferAdd(virBufferPtr buf, const char *str, int len)
-{
-    unsigned int needSize;
-
-    if ((str == NULL) || (buf == NULL)) {
-        return -1;
-    }
-    if (len == 0)
-        return 0;
-
-    if (len < 0)
-        len = strlen(str);
-
-    needSize = buf->use + len + 2;
-    if (needSize > buf->size) {
-        if (!virBufferGrow(buf, needSize - buf->use)) {
-            return (-1);
-        }
-    }
-    /* XXX: memmove() is 2x slower than memcpy(), do we really need it? */
-    memmove(&buf->content[buf->use], str, len);
-    buf->use += len;
-    buf->content[buf->use] = 0;
-    return (0);
-}
-
-virBufferPtr
-virBufferNew(unsigned int size)
-{
-    virBufferPtr buf;
-
-    if (!(buf = malloc(sizeof(*buf)))) {
-        virXMLError(NULL, VIR_ERR_NO_MEMORY, _("allocate new buffer"), sizeof(*buf));
-        return NULL;
-    }
-    if (size && (buf->content = malloc(size))==NULL) {
-        virXMLError(NULL, VIR_ERR_NO_MEMORY, _("allocate buffer content"), size);
-        free(buf);
-        return NULL;
-    }
-    buf->size = size;
-    buf->use = 0;
-
-    return buf;
-}
-
-void
-virBufferFree(virBufferPtr buf)
-{
-    if (buf) {
-        if (buf->content)
-            free(buf->content);
-        free(buf);
-    }
-}
-
-/**
- * virBufferVSprintf:
- * @buf:  the buffer to dump
- * @format:  the format
- * @argptr:  the variable list of arguments
- *
- * Do a formatted print to an XML buffer.
- *
- * Returns 0 successful, -1 in case of internal or API error.
- */
-int
-virBufferVSprintf(virBufferPtr buf, const char *format, ...)
-{
-    int size, count;
-    va_list locarg, argptr;
-
-    if ((format == NULL) || (buf == NULL)) {
-        return (-1);
-    }
-    size = buf->size - buf->use - 1;
-    va_start(argptr, format);
-    va_copy(locarg, argptr);
-    while (((count = vsnprintf(&buf->content[buf->use], size, format,
-                               locarg)) < 0) || (count >= size - 1)) {
-        buf->content[buf->use] = 0;
-        va_end(locarg);
-        if (virBufferGrow(buf, 1000) < 0) {
-            return (-1);
-        }
-        size = buf->size - buf->use - 1;
-        va_copy(locarg, argptr);
-    }
-    va_end(locarg);
-    buf->use += count;
-    buf->content[buf->use] = 0;
-    return (0);
-}
-
-/**
- * virBufferStrcat:
- * @buf:  the buffer to dump
- * @argptr:  the variable list of strings, the last argument must be NULL
- *
- * Concatenate strings to an XML buffer.
- *
- * Returns 0 successful, -1 in case of internal or API error.
- */
-int
-virBufferStrcat(virBufferPtr buf, ...)
-{
-    va_list ap;
-    char *str;
 
-    va_start(ap, buf);
-
-    while ((str = va_arg(ap, char *)) != NULL) {
-        unsigned int len = strlen(str);
-        unsigned int needSize = buf->use + len + 2;
-
-        if (needSize > buf->size) {
-            if (!virBufferGrow(buf, needSize - buf->use))
-                return -1;
-        }
-        memcpy(&buf->content[buf->use], str, len);
-        buf->use += len;
-        buf->content[buf->use] = 0;
-    }
-    va_end(ap);
-    return 0;
-}
-
-
-#ifndef PROXY
 /**
  * virtDomainParseXMLGraphicsDescImage:
  * @conn: pointer to the hypervisor connection
@@ -455,23 +282,23 @@ virBufferStrcat(virBufferPtr buf, ...)
  *
  * Returns 0 in case of success, -1 in case of error
  */
-static int virDomainParseXMLGraphicsDescImage(virConnectPtr conn ATTRIBUTE_UNUSED, xmlNodePtr node, virBufferPtr buf, int xendConfigVersion)
+static int virDomainParseXMLGraphicsDescImage(virConnectPtr conn ATTRIBUTE_UNUSED, xmlNodePtr node, bufferPtr buf, int xendConfigVersion)
 {
     xmlChar *graphics_type = NULL;
 
     graphics_type = xmlGetProp(node, BAD_CAST "type");
     if (graphics_type != NULL) {
         if (xmlStrEqual(graphics_type, BAD_CAST "sdl")) {
-            virBufferAdd(buf, "(sdl 1)", 7);
+            bufferAdd(buf, "(sdl 1)", 7);
             /* TODO:
              * Need to understand sdl options
              *
-             *virBufferAdd(buf, "(display localhost:10.0)", 24);
-             *virBufferAdd(buf, "(xauthority /root/.Xauthority)", 30);
+             *bufferAdd(buf, "(display localhost:10.0)", 24);
+             *bufferAdd(buf, "(xauthority /root/.Xauthority)", 30);
              */
         }
         else if (xmlStrEqual(graphics_type, BAD_CAST "vnc")) {
-            virBufferAdd(buf, "(vnc 1)", 7);
+            bufferAdd(buf, "(vnc 1)", 7);
             if (xendConfigVersion >= 2) {
                 xmlChar *vncport = xmlGetProp(node, BAD_CAST "port");
                 xmlChar *vnclisten = xmlGetProp(node, BAD_CAST "listen");
@@ -480,21 +307,21 @@ static int virDomainParseXMLGraphicsDesc
                 if (vncport != NULL) {
                     long port = strtol((const char *)vncport, NULL, 10);
                     if (port == -1)
-                        virBufferAdd(buf, "(vncunused 1)", 13);
+                        bufferAdd(buf, "(vncunused 1)", 13);
                     else if (port >= 5900)
-                        virBufferVSprintf(buf, "(vncdisplay %ld)", port - 5900);
+                        bufferVSprintf(buf, "(vncdisplay %ld)", port - 5900);
                     xmlFree(vncport);
                 }
                 if (vnclisten != NULL) {
-                    virBufferVSprintf(buf, "(vnclisten %s)", vnclisten);
+                    bufferVSprintf(buf, "(vnclisten %s)", vnclisten);
                     xmlFree(vnclisten);
                 }
                 if (vncpasswd != NULL) {
-                    virBufferVSprintf(buf, "(vncpasswd %s)", vncpasswd);
+                    bufferVSprintf(buf, "(vncpasswd %s)", vncpasswd);
                     xmlFree(vncpasswd);
                 }
                 if (keymap != NULL) {
-                    virBufferVSprintf(buf, "(keymap %s)", keymap);
+                    bufferVSprintf(buf, "(keymap %s)", keymap);
                     xmlFree(keymap);
                 }
             }
@@ -518,25 +345,25 @@ static int virDomainParseXMLGraphicsDesc
  *
  * Returns 0 in case of success, -1 in case of error
  */
-static int virDomainParseXMLGraphicsDescVFB(virConnectPtr conn ATTRIBUTE_UNUSED, xmlNodePtr node, virBufferPtr buf)
+static int virDomainParseXMLGraphicsDescVFB(virConnectPtr conn ATTRIBUTE_UNUSED, xmlNodePtr node, bufferPtr buf)
 {
     xmlChar *graphics_type = NULL;
 
     graphics_type = xmlGetProp(node, BAD_CAST "type");
     if (graphics_type != NULL) {
-        virBufferAdd(buf, "(device (vkbd))", 15);
-        virBufferAdd(buf, "(device (vfb ", 13);
+        bufferAdd(buf, "(device (vkbd))", 15);
+        bufferAdd(buf, "(device (vfb ", 13);
         if (xmlStrEqual(graphics_type, BAD_CAST "sdl")) {
-            virBufferAdd(buf, "(type sdl)", 10);
+            bufferAdd(buf, "(type sdl)", 10);
             /* TODO:
              * Need to understand sdl options
              *
-             *virBufferAdd(buf, "(display localhost:10.0)", 24);
-             *virBufferAdd(buf, "(xauthority /root/.Xauthority)", 30);
+             *bufferAdd(buf, "(display localhost:10.0)", 24);
+             *bufferAdd(buf, "(xauthority /root/.Xauthority)", 30);
              */
         }
         else if (xmlStrEqual(graphics_type, BAD_CAST "vnc")) {
-            virBufferAdd(buf, "(type vnc)", 10);
+            bufferAdd(buf, "(type vnc)", 10);
             xmlChar *vncport = xmlGetProp(node, BAD_CAST "port");
             xmlChar *vnclisten = xmlGetProp(node, BAD_CAST "listen");
             xmlChar *vncpasswd = xmlGetProp(node, BAD_CAST "passwd");
@@ -544,25 +371,25 @@ static int virDomainParseXMLGraphicsDesc
             if (vncport != NULL) {
                 long port = strtol((const char *)vncport, NULL, 10);
                 if (port == -1)
-                    virBufferAdd(buf, "(vncunused 1)", 13);
+                    bufferAdd(buf, "(vncunused 1)", 13);
                 else if (port >= 5900)
-                    virBufferVSprintf(buf, "(vncdisplay %ld)", port - 5900);
+                    bufferVSprintf(buf, "(vncdisplay %ld)", port - 5900);
                 xmlFree(vncport);
             }
             if (vnclisten != NULL) {
-                virBufferVSprintf(buf, "(vnclisten %s)", vnclisten);
+                bufferVSprintf(buf, "(vnclisten %s)", vnclisten);
                 xmlFree(vnclisten);
             }
             if (vncpasswd != NULL) {
-                virBufferVSprintf(buf, "(vncpasswd %s)", vncpasswd);
+                bufferVSprintf(buf, "(vncpasswd %s)", vncpasswd);
                 xmlFree(vncpasswd);
             }
             if (keymap != NULL) {
-                virBufferVSprintf(buf, "(keymap %s)", keymap);
+                bufferVSprintf(buf, "(keymap %s)", keymap);
                 xmlFree(keymap);
             }
         }
-        virBufferAdd(buf, "))", 2);
+        bufferAdd(buf, "))", 2);
         xmlFree(graphics_type);
     }
     return 0;
@@ -586,7 +413,7 @@ static int virDomainParseXMLGraphicsDesc
  * Returns 0 in case of success, -1 in case of error.
  */
 static int
-virDomainParseXMLOSDescHVM(virConnectPtr conn, xmlNodePtr node, virBufferPtr buf, xmlXPathContextPtr ctxt, int vcpus, int xendConfigVersion)
+virDomainParseXMLOSDescHVM(virConnectPtr conn, xmlNodePtr node, bufferPtr buf, xmlXPathContextPtr ctxt, int vcpus, int xendConfigVersion)
 {
     xmlNodePtr cur, txt;
     xmlChar *type = NULL;
@@ -642,12 +469,12 @@ virDomainParseXMLOSDescHVM(virConnectPtr
         virXMLError(conn, VIR_ERR_OS_TYPE, (const char *) type, 0);
         return (-1);
     }
-    virBufferAdd(buf, "(image (hvm ", 12);
+    bufferAdd(buf, "(image (hvm ", 12);
     if (loader == NULL) {
         virXMLError(conn, VIR_ERR_NO_KERNEL, NULL, 0);
         goto error;
     } else {
-        virBufferVSprintf(buf, "(kernel '%s')", (const char *) loader);
+        bufferVSprintf(buf, "(kernel '%s')", (const char *) loader);
     }
 
     /* get the device emulation model */
@@ -656,13 +483,13 @@ virDomainParseXMLOSDescHVM(virConnectPtr
         virXMLError(conn, VIR_ERR_NO_KERNEL, NULL, 0); /* TODO: error */
         goto error;
     }
-    virBufferVSprintf(buf, "(device_model '%s')", str);
+    bufferVSprintf(buf, "(device_model '%s')", str);
     xmlFree(str);
 
-    virBufferVSprintf(buf, "(vcpus %d)", vcpus);
+    bufferVSprintf(buf, "(vcpus %d)", vcpus);
 
     if (nbootorder)
-        virBufferVSprintf(buf, "(boot %s)", bootorder);
+        bufferVSprintf(buf, "(boot %s)", bootorder);
 
     /* get the 1st floppy device file */
 	cur = virXPathNode("/domain/devices/disk[@device='floppy' and target/@dev='fda']/source",
@@ -671,7 +498,7 @@ virDomainParseXMLOSDescHVM(virConnectPtr
         xmlChar *fdfile;
         fdfile = xmlGetProp(cur, BAD_CAST "file");
 	    if (fdfile != NULL) {
-            virBufferVSprintf(buf, "(fda '%s')", fdfile);
+            bufferVSprintf(buf, "(fda '%s')", fdfile);
             free(fdfile);
 	    }
     }
@@ -683,7 +510,7 @@ virDomainParseXMLOSDescHVM(virConnectPtr
         xmlChar *fdfile;
         fdfile = xmlGetProp(cur, BAD_CAST "file");
 	    if (fdfile != NULL) {
-            virBufferVSprintf(buf, "(fdb '%s')", fdfile);
+            bufferVSprintf(buf, "(fdb '%s')", fdfile);
             free(fdfile);
 	    }
     }
@@ -699,7 +526,7 @@ virDomainParseXMLOSDescHVM(virConnectPtr
 
             cdfile = xmlGetProp(cur, BAD_CAST "file");
             if (cdfile != NULL) {
-                virBufferVSprintf(buf, "(cdrom '%s')",
+                bufferVSprintf(buf, "(cdrom '%s')",
                                   (const char *)cdfile);
                 xmlFree(cdfile);
             }
@@ -707,11 +534,11 @@ virDomainParseXMLOSDescHVM(virConnectPtr
     }
 
     if (virXPathNode("/domain/features/acpi", ctxt) != NULL)
-        virBufferAdd(buf, "(acpi 1)", 8);
+        bufferAdd(buf, "(acpi 1)", 8);
     if (virXPathNode("/domain/features/apic", ctxt) != NULL)
-        virBufferAdd(buf, "(apic 1)", 8);
+        bufferAdd(buf, "(apic 1)", 8);
     if (virXPathNode("/domain/features/pae", ctxt) != NULL)
-        virBufferAdd(buf, "(pae 1)", 7);
+        bufferAdd(buf, "(pae 1)", 7);
 
     res = virXPathBoolean("count(domain/devices/console) > 0", ctxt);
     if (res < 0) {
@@ -719,7 +546,7 @@ virDomainParseXMLOSDescHVM(virConnectPtr
         goto error;
     }
     if (res) {
-        virBufferAdd(buf, "(serial pty)", 12);
+        bufferAdd(buf, "(serial pty)", 12);
     }
 
     /* HVM graphics for xen <= 3.0.5 */
@@ -735,7 +562,7 @@ virDomainParseXMLOSDescHVM(virConnectPtr
         }
     }
 
-    virBufferAdd(buf, "))", 2);
+    bufferAdd(buf, "))", 2);
 
     return (0);
 
@@ -759,7 +586,7 @@ virDomainParseXMLOSDescHVM(virConnectPtr
  * Returns 0 in case of success, -1 in case of error.
  */
 static int
-virDomainParseXMLOSDescPV(virConnectPtr conn, xmlNodePtr node, virBufferPtr buf, xmlXPathContextPtr ctxt, int xendConfigVersion)
+virDomainParseXMLOSDescPV(virConnectPtr conn, xmlNodePtr node, bufferPtr buf, xmlXPathContextPtr ctxt, int xendConfigVersion)
 {
     xmlNodePtr cur, txt;
     const xmlChar *type = NULL;
@@ -811,19 +638,19 @@ virDomainParseXMLOSDescPV(virConnectPtr 
         virXMLError(conn, VIR_ERR_OS_TYPE, (const char *) type, 0);
         return (-1);
     }
-    virBufferAdd(buf, "(image (linux ", 14);
+    bufferAdd(buf, "(image (linux ", 14);
     if (kernel == NULL) {
         virXMLError(conn, VIR_ERR_NO_KERNEL, NULL, 0);
         return (-1);
     } else {
-        virBufferVSprintf(buf, "(kernel '%s')", (const char *) kernel);
+        bufferVSprintf(buf, "(kernel '%s')", (const char *) kernel);
     }
     if (initrd != NULL)
-        virBufferVSprintf(buf, "(ramdisk '%s')", (const char *) initrd);
+        bufferVSprintf(buf, "(ramdisk '%s')", (const char *) initrd);
     if (root != NULL)
-        virBufferVSprintf(buf, "(root '%s')", (const char *) root);
+        bufferVSprintf(buf, "(root '%s')", (const char *) root);
     if (cmdline != NULL)
-        virBufferVSprintf(buf, "(args '%s')", (const char *) cmdline);
+        bufferVSprintf(buf, "(args '%s')", (const char *) cmdline);
 
     /* PV graphics for xen <= 3.0.4 */
     if (xendConfigVersion < 3) {
@@ -838,7 +665,7 @@ virDomainParseXMLOSDescPV(virConnectPtr 
     }
 
  error:
-    virBufferAdd(buf, "))", 2);
+    bufferAdd(buf, "))", 2);
     return (0);
 }
 
@@ -878,7 +705,7 @@ virCatchXMLParseError(void *ctx, const c
  * Returns 0 in case of success, -1 in case of error.
  */
 static int
-virDomainParseXMLDiskDesc(virConnectPtr conn, xmlNodePtr node, virBufferPtr buf, int hvm, int xendConfigVersion)
+virDomainParseXMLDiskDesc(virConnectPtr conn, xmlNodePtr node, bufferPtr buf, int hvm, int xendConfigVersion)
 {
     xmlNodePtr cur;
     xmlChar *type = NULL;
@@ -978,14 +805,14 @@ virDomainParseXMLDiskDesc(virConnectPtr 
     }
 
 
-    virBufferAdd(buf, "(device ", 8);
+    bufferAdd(buf, "(device ", 8);
     /* Normally disks are in a (device (vbd ...)) block
        but blktap disks ended up in a differently named
        (device (tap ....)) block.... */
     if (drvName && !strcmp((const char *)drvName, "tap")) {
-        virBufferAdd(buf, "(tap ", 5);
+        bufferAdd(buf, "(tap ", 5);
     } else {
-        virBufferAdd(buf, "(vbd ", 5);
+        bufferAdd(buf, "(vbd ", 5);
     }
 
     if (hvm) {
@@ -996,42 +823,42 @@ virDomainParseXMLDiskDesc(virConnectPtr 
 
         /* Xend <= 3.0.2 wants a ioemu: prefix on devices for HVM */
         if (xendConfigVersion == 1)
-            virBufferVSprintf(buf, "(dev 'ioemu:%s')", (const char *)tmp);
+            bufferVSprintf(buf, "(dev 'ioemu:%s')", (const char *)tmp);
         else /* But newer does not */
-            virBufferVSprintf(buf, "(dev '%s%s')", (const char *)tmp, cdrom ? ":cdrom" : ":disk");
+            bufferVSprintf(buf, "(dev '%s%s')", (const char *)tmp, cdrom ? ":cdrom" : ":disk");
     } else
-        virBufferVSprintf(buf, "(dev '%s')", (const char *)target);
+        bufferVSprintf(buf, "(dev '%s')", (const char *)target);
 
     if (drvName && !isNoSrcCdrom) {
         if (!strcmp((const char *)drvName, "tap")) {
-            virBufferVSprintf(buf, "(uname '%s:%s:%s')",
+            bufferVSprintf(buf, "(uname '%s:%s:%s')",
                               (const char *)drvName,
                               (drvType ? (const char *)drvType : "aio"),
                               (const char *)source);
         } else {
-            virBufferVSprintf(buf, "(uname '%s:%s')",
+            bufferVSprintf(buf, "(uname '%s:%s')",
                               (const char *)drvName,
                               (const char *)source);
         }
     } else if (!isNoSrcCdrom) {
         if (typ == 0)
-            virBufferVSprintf(buf, "(uname 'file:%s')", source);
+            bufferVSprintf(buf, "(uname 'file:%s')", source);
         else if (typ == 1) {
             if (source[0] == '/')
-                virBufferVSprintf(buf, "(uname 'phy:%s')", source);
+                bufferVSprintf(buf, "(uname 'phy:%s')", source);
             else
-                virBufferVSprintf(buf, "(uname 'phy:/dev/%s')", source);
+                bufferVSprintf(buf, "(uname 'phy:/dev/%s')", source);
         }
     }
     if (ro == 1)
-        virBufferVSprintf(buf, "(mode 'r')");
+        bufferVSprintf(buf, "(mode 'r')");
     else if (shareable == 1)
-        virBufferVSprintf(buf, "(mode 'w!')");
+        bufferVSprintf(buf, "(mode 'w!')");
     else
-        virBufferVSprintf(buf, "(mode 'w')");
+        bufferVSprintf(buf, "(mode 'w')");
 
-    virBufferAdd(buf, ")", 1);
-    virBufferAdd(buf, ")", 1);
+    bufferAdd(buf, ")", 1);
+    bufferAdd(buf, ")", 1);
 
  cleanup:
     xmlFree(drvType);
@@ -1057,7 +884,7 @@ virDomainParseXMLDiskDesc(virConnectPtr 
  * Returns 0 in case of success, -1 in case of error.
  */
 static int
-virDomainParseXMLIfDesc(virConnectPtr conn ATTRIBUTE_UNUSED, xmlNodePtr node, virBufferPtr buf, int hvm, int xendConfigVersion)
+virDomainParseXMLIfDesc(virConnectPtr conn ATTRIBUTE_UNUSED, xmlNodePtr node, bufferPtr buf, int hvm, int xendConfigVersion)
 {
     xmlNodePtr cur;
     xmlChar *type = NULL;
@@ -1107,14 +934,14 @@ virDomainParseXMLIfDesc(virConnectPtr co
         cur = cur->next;
     }
 
-    virBufferAdd(buf, "(vif ", 5);
+    bufferAdd(buf, "(vif ", 5);
     if (mac != NULL)
-        virBufferVSprintf(buf, "(mac '%s')", (const char *) mac);
+        bufferVSprintf(buf, "(mac '%s')", (const char *) mac);
     if (source != NULL) {
         if (typ == 0)
-            virBufferVSprintf(buf, "(bridge '%s')", (const char *) source);
+            bufferVSprintf(buf, "(bridge '%s')", (const char *) source);
         else if (typ == 1)      /* TODO does that work like that ? */
-            virBufferVSprintf(buf, "(dev '%s')", (const char *) source);
+            bufferVSprintf(buf, "(dev '%s')", (const char *) source);
         else {
             virNetworkPtr network = virNetworkLookupByName(conn, (const char *) source);
             char *bridge;
@@ -1122,22 +949,22 @@ virDomainParseXMLIfDesc(virConnectPtr co
                 virXMLError(conn, VIR_ERR_NO_SOURCE, (const char *) source, 0);
                 goto error;
             }
-            virBufferVSprintf(buf, "(bridge '%s')", bridge);
+            bufferVSprintf(buf, "(bridge '%s')", bridge);
             free(bridge);
         }
     }
     if (script != NULL)
-        virBufferVSprintf(buf, "(script '%s')", script);
+        bufferVSprintf(buf, "(script '%s')", script);
     if (ip != NULL)
-        virBufferVSprintf(buf, "(ip '%s')", ip);
+        bufferVSprintf(buf, "(ip '%s')", ip);
     /*
      * apparently (type ioemu) breaks paravirt drivers on HVM so skip this
      * from Xen 3.1.0
      */
     if ((hvm) && (xendConfigVersion < 4))
-        virBufferAdd(buf, "(type ioemu)", 12);
+        bufferAdd(buf, "(type ioemu)", 12);
 
-    virBufferAdd(buf, ")", 1);
+    bufferAdd(buf, ")", 1);
     ret = 0;
  error:
     if (mac != NULL)
@@ -1171,7 +998,7 @@ virDomainParseXMLDesc(virConnectPtr conn
     xmlDocPtr xml = NULL;
     xmlNodePtr node;
     char *nam = NULL;
-    virBuffer buf;
+    buffer buf;
     xmlChar *prop;
     xmlParserCtxtPtr pctxt;
     xmlXPathContextPtr ctxt = NULL;
@@ -1221,7 +1048,7 @@ virDomainParseXMLDesc(virConnectPtr conn
         }
         xmlFree(prop);
     }
-    virBufferAdd(&buf, "(vm ", 4);
+    bufferAdd(&buf, "(vm ", 4);
     ctxt = xmlXPathNewContext(xml);
     if (ctxt == NULL) {
         goto error;
@@ -1234,7 +1061,7 @@ virDomainParseXMLDesc(virConnectPtr conn
         virXMLError(conn, VIR_ERR_NO_NAME, xmldesc, 0);
         goto error;
     }
-    virBufferVSprintf(&buf, "(name '%s')", nam);
+    bufferVSprintf(&buf, "(name '%s')", nam);
 
     if ((virXPathNumber("number(/domain/memory[1])", ctxt, &f) < 0) ||
         (f < MIN_XEN_GUEST_SIZE * 1024)) {
@@ -1252,23 +1079,23 @@ virDomainParseXMLDesc(virConnectPtr conn
             max_mem = mem;
         }
     }
-    virBufferVSprintf(&buf, "(memory %lu)(maxmem %lu)", mem, max_mem);
+    bufferVSprintf(&buf, "(memory %lu)(maxmem %lu)", mem, max_mem);
 
     if ((virXPathNumber("number(/domain/vcpu[1])", ctxt, &f) == 0) &&
         (f > 0)) {
         vcpus = (unsigned int) f;
     }
-    virBufferVSprintf(&buf, "(vcpus %u)", vcpus);
+    bufferVSprintf(&buf, "(vcpus %u)", vcpus);
 
     str = virXPathString("string(/domain/uuid[1])", ctxt);
     if (str != NULL) {
-        virBufferVSprintf(&buf, "(uuid '%s')", str);
+        bufferVSprintf(&buf, "(uuid '%s')", str);
 	free(str);
     }
 
     str = virXPathString("string(/domain/bootloader[1])", ctxt);
     if (str != NULL) {
-        virBufferVSprintf(&buf, "(bootloader '%s')", str);
+        bufferVSprintf(&buf, "(bootloader '%s')", str);
         /*
          * if using a bootloader, the kernel and initrd strings are not
          * significant and should be discarded
@@ -1282,25 +1109,25 @@ virDomainParseXMLDesc(virConnectPtr conn
         /*
          * ignore the bootloader_args value unless a bootloader was specified
          */
-        virBufferVSprintf(&buf, "(bootloader_args '%s')", str);
+        bufferVSprintf(&buf, "(bootloader_args '%s')", str);
 	free(str);
     }
 
     str = virXPathString("string(/domain/on_poweroff[1])", ctxt);
     if (str != NULL) {
-        virBufferVSprintf(&buf, "(on_poweroff '%s')", str);
+        bufferVSprintf(&buf, "(on_poweroff '%s')", str);
 	free(str);
     }
 
     str = virXPathString("string(/domain/on_reboot[1])", ctxt);
     if (str != NULL) {
-        virBufferVSprintf(&buf, "(on_reboot '%s')", str);
+        bufferVSprintf(&buf, "(on_reboot '%s')", str);
 	free(str);
     }
 
     str = virXPathString("string(/domain/on_crash[1])", ctxt);
     if (str != NULL) {
-        virBufferVSprintf(&buf, "(on_crash '%s')", str);
+        bufferVSprintf(&buf, "(on_crash '%s')", str);
 	free(str);
     }
 
@@ -1345,13 +1172,13 @@ virDomainParseXMLDesc(virConnectPtr conn
     nb_nodes = virXPathNodeSet("/domain/devices/interface", ctxt, &nodes);
     if (nb_nodes > 0) {
         for (i = 0; i < nb_nodes; i++) {
-            virBufferAdd(&buf, "(device ", 8);
+            bufferAdd(&buf, "(device ", 8);
             res = virDomainParseXMLIfDesc(conn, nodes[i], &buf, hvm, xendConfigVersion);
             if (res != 0) {
 	        free(nodes);
                 goto error;
             }
-            virBufferAdd(&buf, ")", 1);
+            bufferAdd(&buf, ")", 1);
         }
         free(nodes);
     }
@@ -1374,7 +1201,7 @@ virDomainParseXMLDesc(virConnectPtr conn
     }
 
 
-    virBufferAdd(&buf, ")", 1); /* closes (vm */
+    bufferAdd(&buf, ")", 1); /* closes (vm */
     buf.content[buf.use] = 0;
 
     xmlXPathFreeContext(ctxt);
@@ -1485,7 +1312,7 @@ virParseXMLDevice(virConnectPtr conn, ch
 {
     xmlDocPtr xml = NULL;
     xmlNodePtr node;
-    virBuffer buf;
+    buffer buf;
 
     buf.content = malloc(1000);
     if (buf.content == NULL)
Index: src/xml.h
===================================================================
RCS file: /data/cvs/libvirt/src/xml.h,v
retrieving revision 1.14
diff -u -p -r1.14 xml.h
--- src/xml.h	6 Apr 2007 12:28:24 -0000	1.14
+++ src/xml.h	26 Jun 2007 14:27:07 -0000
@@ -15,26 +15,6 @@
 extern "C" {
 #endif
 
-/**
- * virBuffer:
- *
- * A buffer structure.
- */
-typedef struct _virBuffer virBuffer;
-typedef virBuffer *virBufferPtr;
-struct _virBuffer {
-    char *content;          /* The buffer content UTF8 */
-    unsigned int use;       /* The buffer size used */
-    unsigned int size;      /* The buffer size */
-};
-
-virBufferPtr virBufferNew(unsigned int size);
-void virBufferFree(virBufferPtr buf);
-int virBufferAdd(virBufferPtr buf, const char *str, int len);
-int virBufferVSprintf(virBufferPtr buf, const char *format, ...)
-  ATTRIBUTE_FORMAT(printf, 2, 3);
-int virBufferStrcat(virBufferPtr buf, ...);
-
 int		virXPathBoolean	(const char *xpath,
 				 xmlXPathContextPtr ctxt);
 char *		virXPathString	(const char *xpath,
Index: src/xmlrpc.c
===================================================================
RCS file: /data/cvs/libvirt/src/xmlrpc.c,v
retrieving revision 1.6
diff -u -p -r1.6 xmlrpc.c
--- src/xmlrpc.c	14 Feb 2007 15:40:54 -0000	1.6
+++ src/xmlrpc.c	26 Jun 2007 14:27:08 -0000
@@ -305,44 +305,44 @@ void xmlRpcValueFree(xmlRpcValuePtr valu
     free(value);
 }
 
-void xmlRpcValueMarshal(xmlRpcValuePtr value, virBufferPtr buf, int indent)
+void xmlRpcValueMarshal(xmlRpcValuePtr value, bufferPtr buf, int indent)
 {
     int i;
     xmlRpcValueDictElement *elem;
 
-    virBufferVSprintf(buf, "%*s<value>", indent, "");
+    bufferVSprintf(buf, "%*s<value>", indent, "");
     switch (value->kind) {
     case XML_RPC_ARRAY:
-	virBufferStrcat(buf, "<array><data>\n", NULL);
+	bufferStrcat(buf, "<array><data>\n", NULL);
 	for (i = 0; i < value->value.array.n_elements; i++)
 	    xmlRpcValueMarshal(value->value.array.elements[i], buf, indent+2);
-	virBufferVSprintf(buf, "%*s</data></array>", indent, "");
+	bufferVSprintf(buf, "%*s</data></array>", indent, "");
 	break;
     case XML_RPC_STRUCT:
-	virBufferStrcat(buf, "<struct>\n", NULL);
+	bufferStrcat(buf, "<struct>\n", NULL);
 	indent += 2;
 	for (elem = value->value.dict.root; elem; elem = elem->next) {
-	    virBufferVSprintf(buf, "%*s<member>\n", indent, "");
-	    virBufferVSprintf(buf, "%*s<name>%s</name>\n",
+	    bufferVSprintf(buf, "%*s<member>\n", indent, "");
+	    bufferVSprintf(buf, "%*s<name>%s</name>\n",
 			      indent + 2, "", elem->name);
 	    xmlRpcValueMarshal(elem->value, buf, indent + 2);
-	    virBufferVSprintf(buf, "%*s</member>\n", indent, "");
+	    bufferVSprintf(buf, "%*s</member>\n", indent, "");
 	}
 	indent -= 2;
-	virBufferVSprintf(buf, "%*s</struct>", indent, "");
+	bufferVSprintf(buf, "%*s</struct>", indent, "");
 	break;
     case XML_RPC_INTEGER:
-	virBufferVSprintf(buf, "<int>%d</int>", value->value.integer);
+	bufferVSprintf(buf, "<int>%d</int>", value->value.integer);
 	break;
     case XML_RPC_DOUBLE:
-	virBufferVSprintf(buf, "<double>%f</double>", value->value.real);
+	bufferVSprintf(buf, "<double>%f</double>", value->value.real);
 	break;
     case XML_RPC_BOOLEAN:
 	if (value->value.boolean)
 	    i = 1;
 	else
 	    i = 0;
-	virBufferVSprintf(buf, "<boolean>%d</boolean>", i);
+	bufferVSprintf(buf, "<boolean>%d</boolean>", i);
 	break;
     case XML_RPC_DATE_TIME:
 	/* FIXME */
@@ -353,37 +353,37 @@ void xmlRpcValueMarshal(xmlRpcValuePtr v
 	TODO
 	break;
     case XML_RPC_STRING:
-	virBufferStrcat(buf, 
+	bufferStrcat(buf, 
 		"<string>", value->value.string, "</string>", NULL);
 	break;
     case XML_RPC_NIL:
-	virBufferStrcat(buf, "<nil> </nil>", NULL);
+	bufferStrcat(buf, "<nil> </nil>", NULL);
 	break;
     }
-    virBufferStrcat(buf, "</value>\n", NULL);
+    bufferStrcat(buf, "</value>\n", NULL);
 }
 
-virBufferPtr xmlRpcMarshalRequest(const char *request,
+bufferPtr xmlRpcMarshalRequest(const char *request,
 				  int argc, xmlRpcValuePtr *argv)
 {
-    virBufferPtr buf;
+    bufferPtr buf;
     int i;
 
-    buf = virBufferNew(1024);
+    buf = bufferNew(1024);
 
-    virBufferStrcat(buf,
+    bufferStrcat(buf,
 		    "<?xml version=\"1.0\"?>\n"
 		    "<methodCall>\n"
 		    "  <methodName>", request, "</methodName>\n"
 		    "  <params>\n", NULL);
     for (i = 0; i < argc; i++) {
-	virBufferStrcat(buf,  
+	bufferStrcat(buf,  
                     "    <param>\n", NULL);
 	xmlRpcValueMarshal(argv[i], buf, 6);
-	virBufferStrcat(buf,  
+	bufferStrcat(buf,  
                     "    </param>\n", NULL);
     }
-    virBufferStrcat(buf,
+    bufferStrcat(buf,
                     "  </params>\n"
 		    "</methodCall>\n", NULL);
     return buf;
@@ -564,7 +564,7 @@ int xmlRpcCall(xmlRpcContextPtr context,
     va_list ap;
     int argc;
     xmlRpcValuePtr *argv;
-    virBufferPtr buf;
+    bufferPtr buf;
     char *ret;
     xmlDocPtr xml;
     xmlNodePtr node;
@@ -591,7 +591,7 @@ int xmlRpcCall(xmlRpcContextPtr context,
     
     ret = xmlRpcCallRaw(context->uri, buf->content);
 
-    virBufferFree(buf);
+    bufferFree(buf);
 
     if (!ret)
 	return -1;
